/*
 *	TOPPERS Software
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *	
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2011 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *  $Id: prc_sil.h 857 2011-07-22 05:50:52Z mit-kimai $
 */

/*
 *	sil.hΥץå¸SH2A-DUALѡ
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ǥȿž
 */
Inline uint16_t toppers_sil_rev_endian_uint16(uint16_t src)
{
	uint16_t dst;
	Asm("swap.b %1, %0" : "=r"(dst) : "r"(src) );
	return dst;
}

#define	TOPPERS_SIL_REV_ENDIAN_UINT16(data) \
		toppers_sil_rev_endian_uint16(data)

Inline uint32_t toppers_sil_rev_endian_uint32(uint32_t src)
{
	uint32_t dst;
	Asm("swap.b %1, %0 \n"		/*  0x12340x1243  */
		"swap.w %0, %0 \n" 		/*  0x12430x4312  */
		"swap.b %0, %0"			/*  0x43120x4321  */
		: "=r"(dst) : "r"(src) );
	return dst;
}

#define	TOPPERS_SIL_REV_ENDIAN_UINT32(data) \
		toppers_sil_rev_endian_uint32(data)


/*
 *	쥸ؿ
 *	sil_re?_mem,sil_wr?_mem򤳤ΥեǻѤ
 *	λƤʤᡢƱδؿѰդ롣
 */

/*
 *	8ӥåȡ쥸ɽФ
 */
Inline uint8_t
sil_reb_reg(uint8_t *p_reg)
{
	uint8_t	data;

	data = *((volatile uint8_t *)p_reg);
	return(data);
}

Inline void
sil_wrb_reg(uint8_t *p_reg, uint8_t data)
{
	*((volatile uint8_t *)p_reg) = data;
}

/*
 *	16ӥåȡ쥸ɽФ
 */
Inline uint16_t
sil_reh_reg(uint16_t *p_reg)
{
	uint16_t	data;

	data = *((volatile uint16_t *)p_reg);
	return(data);
}

Inline void
sil_wrh_reg(uint16_t *p_reg, uint16_t data)
{
	*((volatile uint16_t *)p_reg) = data;
}

/*
 *	32ӥåȡ쥸ɽФ
 */
Inline uint32_t
sil_rew_reg(uint32_t *p_reg)
{
	uint32_t	data;

	data = *((volatile uint32_t *)p_reg);
	return(data);
}

Inline void
sil_wrw_reg(uint32_t *p_reg, uint32_t data)
{
	*((volatile uint32_t *)p_reg) = data;
}

/*
 *	쥸Ф黻
 */

/*
 *	8ӥåȡ쥸OR黻
 */
Inline void
sil_orb_reg(uint8_t *p_reg, uint_t bitptn)
{
	uint8_t reg_val = sil_reb_reg(p_reg);

	reg_val |= (uint8_t)bitptn;
	sil_wrb_reg(p_reg, reg_val);
}

/*
 *	8ӥåȡ쥸AND黻
 */
Inline void
sil_anb_reg(uint8_t *p_reg, uint_t bitptn)
{
	uint8_t reg_val = sil_reb_reg(p_reg);

	reg_val &= (uint8_t)bitptn;
	sil_wrb_reg(p_reg, reg_val);
}

/*
 *	16ӥåȡ쥸OR黻
 */
Inline void
sil_orh_reg(uint16_t *p_reg, uint_t bitptn)
{
	uint16_t reg_val = sil_reh_reg(p_reg);

	reg_val |= (uint16_t)bitptn;
	sil_wrh_reg(p_reg, reg_val);
}


/*
 *	16ӥåȡ쥸AND黻
 */
Inline void
sil_anh_reg(uint16_t *p_reg, uint_t bitptn)
{
	uint16_t reg_val = sil_reh_reg(p_reg);

	reg_val &= (uint16_t)bitptn;
	sil_wrh_reg(p_reg, reg_val);
}


/*
 *	16ӥåȡ쥸Υӥåȡåȡꥢ
 */
Inline void
sil_seth_bit(uint16_t *p_reg, uint_t bit)
{
	uint32_t reg_val = sil_reh_reg(p_reg);

	/*
	 *	bit7ʲǤС
	 *	bset̿Ÿ뤳Ȥ
	 */
	reg_val |= (1U << bit);
	sil_wrh_reg(p_reg, reg_val);
}

Inline void
sil_clrh_bit(uint16_t *p_reg, uint_t bit)
{
	uint32_t reg_val = sil_reh_reg(p_reg);

	/*
	 *	bit7ʲǤС
	 *	bclr̿Ÿ뤳Ȥ
	 */
	reg_val &= ~(1U << bit);
	sil_wrh_reg(p_reg, reg_val);
}


/*
 *	ץåINDEX0ꥸˤμ
 *	
 *	CPU00
 *	CPU11
 */
Inline uint_t
sil_get_pindex(void)
{
	uint_t index;
	uint32_t cpuidr = sil_rew_reg((uint32_t *)CPUIDR_w);
	
	if ((cpuidr & CPUIDR_ID_BIT) == 0U) {
		index = 0U;
	} else {
		index = 1U;
	}
	return index;
}

/*
 *	ץåIDμ
 *	
 *	CPU01
 *	CPU12
 */
Inline void
sil_get_pid(ID *p_id)
{
	*p_id = sil_get_pindex() + 1U;
}


/*
 *	NMI٤Ƥγߤζػ
 */
Inline uint32_t
TOPPERS_disint(void)
{
	uint32_t  TOPPERS_sr, TOPPERS_iimp;

	Asm("stc  sr,%0" : "=r"(TOPPERS_sr));
	TOPPERS_iimp = TOPPERS_sr & 0x000000f0U;
	Asm("ldc %0, sr" : : "r"(TOPPERS_sr | 0x000000f0U) : "memory", "t");
	return(TOPPERS_iimp);
}

/*
 *	ͥ٥ޥɽˤθͤ
 */
Inline void
TOPPERS_set_iipm(uint32_t TOPPERS_iipm)
{
	uint32_t  TOPPERS_sr;

	Asm("stc  sr,%0" : "=r"(TOPPERS_sr));
	TOPPERS_sr = (TOPPERS_sr & ~0x000000f0U) | TOPPERS_iipm;
	Asm("ldc %0, sr" : : "r"(TOPPERS_sr) : "memory", "t");
}

#ifdef ENABLE_CACHE
Inline void
TOPPERS_set_iipm_with_nop(uint32_t TOPPERS_iipm)
{
	uint32_t  TOPPERS_sr;

	Asm("stc  sr,%0" : "=r"(TOPPERS_sr));
	TOPPERS_sr = (TOPPERS_sr & ~0x000000f0U) | TOPPERS_iipm;
	Asm("ldc %0, sr;"
		"nop; nop"		/*  CPUINTCãޤǤٱ  */
	 	: : "r"(TOPPERS_sr) : "memory", "t");
}
#else	/*  ENABLE_CACHE  */
#define TOPPERS_set_iipm_with_nop(TOPPERS_iipm)	TOPPERS_set_iipm(TOPPERS_iipm)
#endif	/*  ENABLE_CACHE  */

/*
 *	ߥå֤
 *	
 *	ǥޥ졼󤷡ΥץåȰۤʤץå
 *	SR쥸ؤν񤭹ߤιͻ
 *	
 *	ޥ졼ȯΤϡޥ졼󸵥ץå
 *	ץå
 *	ߥå֡
 *	ͥ٥ޥ
 *	ξ˸¤Τǡޥ졼Ǽ¹ԺƳݤˤϡ
 *	嵭ξ֤ˤʤäƤꡢSR쥸񤭤Ƥʤ
 */
#define SIL_PRE_LOC 	 uint32_t TOPPERS_saved_iipm
#define SIL_LOC_INT()	 ((void)(TOPPERS_saved_iipm = TOPPERS_disint()))
#define SIL_UNL_INT()	 (TOPPERS_set_iipm_with_nop(TOPPERS_saved_iipm))

/*
 *  SILԥå֥å
 */
typedef struct toppers_sil_spn_cb {
	/*
	 *  SILԥåƤץåID
	 *  SILԥåݤˤ0᤹
 	*/
	ID spn_prcid;

	/*
	 *  SILԥåΥͥȲ
	 *  SILԥåݤˤ0᤹
	 */
	uint_t spn_nest;
} TOPPERS_SIL_SPN_CB;;


/*
 *  SILԥå֥åprc_config.c
 */
extern TOPPERS_SIL_SPN_CB TOPPERS_sil_spn_cb;

/*
 *	ԥåμ
 */
Inline uint32_t
TOPPERS_sil_loc_spn(void)
{
	uint32_t saved_iipm;
	ID prcid;
	uint8_t semr0;
	uint8_t *p_semr0_b = (uint8_t *)SEMR0_b;

  retry:
	/* ߥå֤*/
	saved_iipm = TOPPERS_disint();

	sil_get_pid(&prcid);
	if(TOPPERS_sil_spn_cb.spn_prcid == prcid) {
		/*  ԥåؤϤʤʼѤߡ  */
		++TOPPERS_sil_spn_cb.spn_nest;
	} else {
		semr0 = sil_reb_reg(p_semr0_b);
			/*
			 *	SEMR0 == 0 
			 *	SEMR0 == 1 
			 */
		if (semr0 == 0) {
			/* ԥåǤʤä */
			/* ߥå֤ξ֤ */
			TOPPERS_set_iipm_with_nop(saved_iipm);
			goto retry;
		} else {
			/* ԥåǤ */
			TOPPERS_sil_spn_cb.spn_prcid = prcid;
			TOPPERS_sil_spn_cb.spn_nest = 1;
		}
	}
	/* Ƥ񤭴ǽ */
	Asm("":::"memory");
	return saved_iipm;
}

/*
 *	ԥåβ
 */
Inline void
TOPPERS_sil_unl_spn(uint32_t saved_iipm)
{
	/* Ƥ񤭴ǽ */
	Asm("":::"memory");
	--TOPPERS_sil_spn_cb.spn_nest;
	if(TOPPERS_sil_spn_cb.spn_nest != 0) {
		/*
		 *  ͥȤƤ
		 *  ԥåؤϤʤ
		 */
	} else {
		/*
		 *  ͥȤƤʤ
		 *  ºݤ˥ԥåβԤ
		 */
		TOPPERS_sil_spn_cb.spn_prcid = 0U;
		Asm("":::"memory");
		sil_wrb_reg((uint8_t *)SEMR0_b, SEMR_SEMF_BIT);

		/* ߥå֤ξ֤ */
		TOPPERS_set_iipm_with_nop(saved_iipm);
	}
}

/*
 *  ԥåζ
 *  ץåԥåƤ˲롥 
 */
Inline void
TOPPERS_sil_force_unl_spn(void)
{
	ID prcid;

	sil_get_pid(&prcid);

	if (TOPPERS_sil_spn_cb.spn_prcid == prcid) {
		TOPPERS_sil_spn_cb.spn_prcid = 0U;
		TOPPERS_sil_spn_cb.spn_nest = 0;
		Asm("":::"memory");
		sil_wrb_reg((uint8_t *)SEMR0_b, SEMR_SEMF_BIT);
	}
}

/*
 *	ԥå
 */
#define SIL_LOC_SPN() ((void)(TOPPERS_saved_iipm = TOPPERS_sil_loc_spn()))
#define SIL_UNL_SPN() (TOPPERS_sil_unl_spn(TOPPERS_saved_iipm))

/*
 *	SILԥåͥȤƼǽǤ뤳Ȥ򼨤ޥ
 */
#define TOPPERS_TARGET_SUPPORT_NESTED_SIL_SPINLOC


#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_SIL_H */
