/*
 *	TOPPERS/FMP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *									Toyohashi Univ. of Technology, JAPAN
 *	Copyright (C) 2007		by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2008-2011 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 * 
 *  $Id: start.S 800 2011-05-02 08:08:34Z mit-kimai $
 */

/*
 *	ͥбΥȥåץ⥸塼(SH2A-DUAL)
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val) 	(val)		 /* uint_tޥ */
#define ULONG_C(val)	(val)		 /* ulong_tޥ */
#define CAST(type, val) (val)		 /* 㥹ȤԤޥ */
#include "kernel_impl.h"
#include "prc_asm.inc"

/*
 *	TOPPERS_MASTER_PRCID==1ꤷƤ롣
 *	ʥޥץåID=1
 */
#if TOPPERS_MASTER_PRCID != 1
#error TOPPERS_MASTER_PRCID != 1
#endif

/*
 *	Υ
 *	
 *	ʲΥ󥹤ǥץå֤Ʊ롣
 *	
 *	CPU0CPU1
 *	åȰ¸target_support.S
 *	ޥե쥸SEM0å
 *	
 *	å		å
 *	FRQCR1ʳFRQCR1Τ
 *	
 *	®¢RAM0ؤΥSYSCRn
 *	
 *	®¢RAM1ؤΥSYSCRn
 *	®¢RAM1ѿcpu1_flag0
 *	®¢RAM1̿ᥳɤ򥳥ԡ
 *	ԡ̿ᥳɤʬ
 *	SEM0Ԥ			SEM0꡼...(1)
 *	
 *	ؤΥ
 *	ʥХơȥν
 *										
 *	ƥ¸start.S
 *	bss/dataν
 *	software_init_hook()θƤӽФ
 *	target_mprc_initialize()θƤӽФ
 *	
 *	cpu1_flag1		cpu1_flag=1ȤʤޤԤ...(2)
 *	
 *	CPU0CPU1Ϥǹή롣
 *	åνʳCPU
 *	ͥ뵯ư
 *	sta_ker()θƤӽФ
 *	
 *	
 *  ¾ץåƱˤϡ
 *  sleep̿ܥץåֳ
 *  ޥե쥸Ȥä¾
 *  RAMؤtest & set̿
 *  ΣĤͤ롣
 *  
 *  ƤѾˤꡢʲ»ब롣
 *  
 *  ߥå
 *  ץåֳߤϻѤǤʤ
 *  
 *  åȿ
 *  FRQCR1쥸CPU1Τǽ
 *  
 *  ®¢RAMؤΥSYSCRnν
 *  ¾ץåϹ®¢ؤΥԲ
 *  ʹ®¢֤줿̿ؤ̿եåԲġ
 *  
 *  ؤΥ
 *  ʥХơȥȥν
 *  ¾ץåϳؤΥԲ
 *  ʳ֤줿̿ؤ̿եåԲġ
 *  
 *  Ǥϡ
 *	CPU0Ԥľ硧ޥե쥸
 *	CPU1Ԥľ硧®¢RAM1Υե饰ѿ
 *  ѤƤ롣
 *	ե饰ѤΤϡ
 *	CPU1CPUХư뤿
 *	target_mprc_initialize()ȴĤʤ
 *	ǥޥե쥸Ƥ롣
 */
	.text
	.global _start
	.align 2
_start:
	/*
	 *	SR롣
	 *	ߥåȤ롣
	 */
	movi20 #IIPM_DISALL, r0
	ldc    r0, sr

	/*
	 *	󥿥ƥѥåν
	 */
	my_prc_index r10 r1 labal_skip1 _cpuidr_val		/*  r10prcindex  */
	mov    r10, r11
	shll2  r11								/*  r11:ơ֥Υǥå  */
	mov.l  _istkpt_table_p, r1				/*  ơ֥Ƭɥ쥹  */
	add    r11, r1
	mov.l  @r1, r15							/*  r15my_istkpt  */

	/*
	 *	_hardware_init_hook ƤӽФ(0Ǥʤ)
	 *
	 *	åȥϡɥ˰¸ɬפʽϡ
	 *	hardware_init_hookȤؿѰդ롥
	 *
	 *	ʲξ֤ʬ롣
	 *	r4:ץåINDEX
	 *	r5:ơ֥Υǥå=ץåINDEX*4
	 */
start_0:
	mov.l  _hardware_init_hook_start, r0
	tst    r0, r0
	bt	   start_1
	mov    r10, r4
	mov    r11, r5
	jsr/n  @r0

    /*
     *  ޥץåǤʤСͥư
     *  _hardware_init_hookCPU1cpu1_flag=1ȤʤޤԤäƤ롣
     *  Ʊݥ(2)
     */
start_1:
	mov    r10, r0							/*  r0prcindex  */
	cmp/eq #(TOPPERS_MASTER_PRCID - 1), r0
	bf     start_8

    /*******************************
     *  ޥץåξν
     ********************************/

	/*
	 * bss򥯥ꥢ
	 *
	 *	ƥ4Хȶ֤ƤΤǡ
	 *	_end4ХȶǤʤȤƤ⡢
	 *	٤Υ񤭤뤳ȤϤʤ
	 *	ʲdataνƱ͡
	 */
	mov.l  _bss_start_p, r1
	mov.l  _end_p, r2
	cmp/eq r1, r2
	bt	   start_3
	mov    #0, r0
	/*
	 *	ٱ䥹åȡ(a)ԡˤϡ롼פæФݤˤ
	 *	¹ԤΤǡͽᡢ롼פβ1󸺤餷Ƥ
	 *	ա_endϤ3ʲȱ黻̤ˤʤꡢNG
	 */
	add    #-4, r2
start_2:
	cmp/hi r1, r2
	bt/s   start_2
	 mov.l  r0, @r1+	/*  (a) 쥸r0 */

	/*
	 *	dataROMбˡ
	 *
	 *	__idata_start  __idata_end ޤǤ__data_start ʹߤ
	 *	ԡ롥
	 */
start_3:
	mov.l  __idata_start_p, r1
	mov.l  __idata_end_p, r2
	cmp/eq r1, r2
	bt	   start_5
	mov.l  __data_start_p, r3
	/*
	 *	ٱ䥹åȡ(b)ԡˤϡ롼פæФݤˤ
	 *	¹ԤΤǡͽᡢ롼פβ1󸺤餷Ƥ
	 *	ա__idata_endϤ3ʲȱ黻̤ˤʤꡢNG
	 */
	add    #-4, r2
start_4:
	mov.l  @r1+, r0
	cmp/hi r1, r2
	bt/s   start_4
	 mov.l  r0, @r3+	/*  (b)쥸r0  */

	/*
	 *	_software_init_hook ƤӽФ0 Ǥʤˡ
	 *
	 *	եȥĶä˥饤֥ˤ˰¸ɬפʽ
	 *	ϡsoftware_init_hook ȤؿѰդ
	 *	褤
	 */
start_5:
	mov.l  _software_init_hook_start, r0
	tst    r0, r0
	bt	   start_6
	jsr/n  @r0

    /*
     *  target_mprc_initialize θƤӽФ
     *
     *  sta_ker ˥ޥץåΤߤǹԤɬפΤ¹
     */
start_6:
	mov.l  _target_mprc_initialize_start, r0
	tst    r0, r0
	bt	   start_7
	jsr/n  @r0

start_7:
	/*
	 *	CPU1ȤƱݥ(2)
	 *CPU1Τ롣
	 */
	mov.l  _cpu1_flag_shadow_addr, r1
	mov    #1, r2
	mov.l  r2, @r1			/*  cpu1_flag_shadow1  */

	/*
	 *	CPU0CPU1Ϥǹή롣
	 */
start_8:
    /*
     *  åν
     *  ֤ƤΤϡƱɤCPU0CPU1
     *  줾쥭å0ȥå1Ǥ뤿
     *  
     *  åνϥå̵֤ǹԤɬפ뤿ᡢ
     *  ؿƤӽФκݤˡʬ襢ɥ쥹Υӥå29򥻥åȤƤ롣
     *  0x2000,0000or黻ƤΤϡǽ餫_cache_init
     *  å̵֤˥ޥåԥ󥰤Ƥк
     *  
     *  ɥ쥹ޥåסʳΤȴˡ
     *  0x0000,0000 - 0x1fff,ffffåͭ
     *  0x2000,0000 - 0x3fff,ffffå̵֡ʥɡ֡
     */
#ifdef ENABLE_CACHE
	mov.l  _cache_init_p, r1
	mov.l  _non_cachable_addr_top, r2
	or     r2, r1
	jsr/n  @r1
#endif /* ENABLE_CACHE */

	/*
	 *	ͥư
	 */
	mov.l  _sta_ker_start, r0
	jsr/n  @r0


    /*
     *  åν
     */
#ifdef ENABLE_CACHE
_cache_init:
    mov.l _ccr1_addr_w, r1
								/*  å塦եå  */
    movi20 #(CCR1_ICF | CCR1_OCF), r0
    mov.l r2, @r1
    mov.l _ccr_init_val, r2		/*  ͤϥåȰ¸  */
    mov.l r2, @r1
    mov.l @r1, r2				/*  ߡ꡼  */
    rts/n						/*  ǰΤᡢٱ䥹åȤˤ֤ʤ*/
#endif /* ENABLE_CACHE */

	.align 2
_cpuidr_val:
	.long CPUIDR_ID_BIT
_istkpt_table_p:
	.long _istkpt_table

_bss_start_p:
	.long __bss_start
_end_p:
	.long _end
__idata_start_p:
	.long __idata_start
__idata_end_p:
	.long __idata_end
__data_start_p:
	.long __data_start

_hardware_init_hook_start:
	.long _hardware_init_hook
_software_init_hook_start:
	.long _software_init_hook
_target_mprc_initialize_start:
	.long _target_mprc_initialize
_sta_ker_start:
	.long _sta_ker

_cpu1_flag_shadow_addr:
	.long INNER_RAM1_PAGE0_SHADOW_START

#ifdef ENABLE_CACHE
_cache_init_p:
	.long _cache_init
_non_cachable_addr_top:
	.long 0x20000000
_ccr1_addr_w:
	.long CCR1_w
_ccr_init_val:
	.long CCR1_INIT			/*  ͤϥåȰ¸  */
#endif /* ENABLE_CACHE */
