/*
 *	TOPPERS/FMP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2009-2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 * 
 *  $Id: target_config.c 765 2011-01-13 07:18:55Z mit-kimai $
 */

/*
 *	åȰ¸⥸塼APSH2ADѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "pdic/sh/sh_scif.h"
#include "apsh2ad.h"
#include "target_syssvc.h"		/*  TNUM_PORT  */

/*
 *  Хơȡȥȥԥ󡦥ե󥯥󡦥ȥν
 *  
 *  δؿϡCPU0hardware_init_hook()ʲξ
 *  ƤӽФȤꤷƤ롣
 *  åݥ󥿤¢RAMؤƤ롣
 *  ¾ΥץåCPU1ˤХ˥Ƥʤ
 *  
 *  δؿϡȥåץ롼Ρbss/dataνפ
 *  ˼¹Ԥɬפ뤿ᡢtarget_mprc_initialize()Ȥ̴ؿȤƤ롣
 */
extern void target_bsc_pfc_initialize(void);

void target_bsc_pfc_initialize(void)
{
#ifdef ROM_BOOT
	/* Хȥ */
	sil_wrw_mem((void *)CSMOD0_w, 0x00000000);
				/* CS0⡼ɥ쥸 */
				/* PRMOD  0 =Ρޥ륢ߴ⡼ */
				/* PWENB  0 =ڡ饤ȥػ */
				/* PRENB  0 =ڡ꡼ɥػ */
				/* EWENB  0 =ȶػ */
				/* WRMOD  0 =Хȥ饤ȥȥ֥⡼ */

	sil_wrw_mem((void *)CS1WCNT0_w, 0x07070000);	
				/* CS1쥸1 */
				/* CSRWAIT  00110=6ȥ */
				/* CSWWAIT  00110=6ȥ */
				/* CSPRWAIT   000=0ȥ */
				/* CSPWWAIT   000=0ȥ */

	sil_wrw_mem((void *)CS2WCNT0_w, 0x12210011);	
				/* CS2쥸1 */
				/* CSON   001=1ȥ */
				/* WDON   010=2ȥ */
				/* WRON   010=2ȥ */
				/* RDON   001=1ȥ */
				/* WDOOFF 000=0ȥ */
				/* CSWOFF 001=1ȥ */
				/* CSROFF 001=1ȥ */

#endif /* ROM_BOOT */

	/* I/O */
	sil_wrh_mem((void *)PACRL4_h, 0x1111);		/* D31~16 */
	sil_wrh_mem((void *)PACRL3_h, 0x1111);
	sil_wrh_mem((void *)PACRL2_h, 0x1111);
	sil_wrh_mem((void *)PACRL1_h, 0x1111);

	sil_wrh_mem((void *)PBCRH2_h, 0x0001);		/* WDTOVF */
	sil_wrh_mem((void *)PBCRH1_h, 0x0001);		/* PB17 SDWE */
	sil_wrh_mem((void *)PBCRL4_h, 0x1111);		/* CKE CAS RAS WE3 */
	sil_wrh_mem((void *)PBCRL3_h, 0x1111);		/* WE2 WE1 WE0 CS5 */
	sil_wrh_mem((void *)PBCRL2_h, 0x2111);		/* SDCS0 CS3 CS2 CS1 */
	sil_wrh_mem((void *)PBCRL1_h, 0x1111);		/* A22 A21 A1 A0 */

	sil_wrh_mem((void *)PCCRL3_h, 0x0000);		/* PC10~0 */
	sil_wrh_mem((void *)PCCRL2_h, 0x0000);
	sil_wrh_mem((void *)PCCRL1_h, 0x0000);

	sil_wrh_mem((void *)PCIORL_h, 0x07FF);		/* OUT : PC10~0 */

	sil_wrh_mem((void *)PDCRL1_h, 0x0222);		/* A25 A24 A23 */

	sil_wrh_mem((void *)PECRL1_h, 0x1111);		/* RTS0 CTS0 TxD0 RxD0 */

	sil_wrh_mem((void *)PFCRL2_h, 0x0000);		/* LED2 */
	sil_wrh_mem((void *)PFCRL1_h, 0x0330);		/* LED1 CTx0 CRx0 PF0 */

	sil_wrh_mem((void *)PFIORL_h, 0x0019);
						/* OUT : LED2(PF4) LED1(PF3) PF0 */

	sil_wrh_mem((void *)PHIORL_h, 0x0280);
						/* PH7,PH8:USBHOST0 PH9,PH10:USBHOST1 PH6:WP*/

	sil_wrh_mem((void *)PJCRL4_h, 0x0000);		/* PJ12~0 */
	sil_wrh_mem((void *)PJCRL3_h, 0x0000);
	sil_wrh_mem((void *)PJCRL2_h, 0x0000);
	sil_wrh_mem((void *)PJCRL1_h, 0x0000);

	sil_wrh_mem((void *)PJIORL_h, 0x1FFF);		/* OUT : PJ12~0 */

#ifdef ROM_BOOT

	sil_wrw_mem((void *)SDIR0_w, 0x00000082);	/* SDRAM쥸0 */
				/* DPC   ץ㡼(000=3) */
				/* DARFC ȥեå(1000=8) */
				/* DARFI ȥեåֳ(0010=5) */

	sil_wrw_mem((void *)SDIR1_w, 0x00000001);	/* SDRAM쥸1 */
				/* DINIRQ  󥹳 */

	/* SDRAMλԤ */
	while( (sil_rew_mem((void *)SDIR1_w) & 0x00010000) != 0 );

	/* SDRAMơ쥸γǧ */
	while( sil_rew_mem((void *)SDSTR_w) != 0);

	sil_wrw_mem((void *)SD0MOD_w, 0x00000020);
				/* SDRAM0⡼ɥ쥸 */
				/* A9   饤ȥСĹ(0=Burst) */
				/* A8-7 ƥȥ⡼(00=Mode Reister Set) */
				/* A6-4 CAS쥤ƥ(010=2) */
				/* A3   Сȥ(0=Sequential) */
				/* A2-1 СĹ(000=1) */

	sil_wrw_mem((void *)SD0TR_w, 0x00021302);	/* SDRAM0ߥ󥰥쥸 */
				/* DRAS ƥִ(010=3) */
				/* DRCD 쥤ƥ󥷴(01=2) */
				/* DPCG ץ㡼(001=2) */
				/* DWR  饤ȥꥫХ(1=2) */
				/* DCL  CAS쥤ƥ(010=2) */

	sil_wrw_mem((void *)SD0ADR_w, 0x00000203);
				/* SDRAM0ɥ쥹쥸 */
				/* DDBW SDRAMǡХ(10=32ӥå) */
				/* DSZ  ͥ륵(011=32MХ) */

	sil_wrw_mem((void *)SDRFCNT1_w, 0x00014208);
				/* SDRAMեå쥸1 */
				/* DRFEN ȥեåư(1=ͭ) */
				/* DREFW ȥեå奵(0100=5) */
				/* DRFC  ȥեå׵ֳ */
				/* 64mS/4096=1.56us */

	sil_wrw_mem((void *)SDC0CNT_w, 0x00110000);
				/* SDRAMC0쥸 */
				/* BSIZE Х(01=32ӥåȥХ) */
				/* EXENB ư(1=ư) */
#endif /* ROM_BOOT */
}


/*
 *  str_ker() μ¹˥ޥץåΤ߼¹Ԥ
 */
void
target_mprc_initialize(void)
{
	prc_mprc_initialize();

	/*
	 *	ϥ⡼ɤ
	 */
		/*
		 *	CPU0sleep̿μ¹ԤǡCPU0꡼ץ⡼ɤ
		 *	꡼ץ顼ػ
		 *	ǥѿ徽ȯҤ̵
		 */
	sil_wrb_mem((void *)STBCR1_b, STBCR1_AXTALE);

		/*
		 *	H-UDIư
		 *	FPU0,FPU1ư
		 *	UBC0,UBC1ư
		 *	
		 *	
		 *	JTAGߥ졼Ѥϡ
		 *	H-UDIFPUUBCߤƤϤʤ
		 */
	sil_wrb_mem((void *)STBCR2_b, 0x00U);

		/*
		 *	ATAPI
		 *	MTU2
		 *	ADC
		 *	DAC
		 *	RTC
		 */
	sil_wrb_mem((void *)STBCR3_b, 0xffU);

		/*
		 *	SCFI0ư
		 *	SCFI1ư
		 *	SCFI2
		 *	SCFI3
		 *	SCFI4
		 *	SCFI5
		 */
	sil_wrb_mem((void *)STBCR4_b, (uint8_t)~(STBCR4_SCIF0 | STBCR4_SCIF1));

		/*
		 *	IIC3_0
		 *	IIC3_1
		 *	IIC3_2
		 *	IIC3_3
		 *	RCAN0
		 *	RCAN1
		 */
	sil_wrb_mem((void *)STBCR5_b, 0xffU);

		/*
		 *	SSIF0
		 *	SSIF1
		 *	SSIF2
		 *	SSIF3
		 *	SSIF4
		 *	SSIF5
		 */
	sil_wrb_mem((void *)STBCR6_b, 0xffU);

		/*
		 *	CMT01ư
		 *	CMT23
		 *	FLCTL
		 *	SSU0
		 *	SSU1
		 *	2DG
		 *	USB
		 */
	sil_wrb_mem((void *)STBCR7_b, (uint8_t)~STBCR7_CMT01);

	/*
	 *	SCIFI/OݡȤ	 ׸Ƥ:PE4/SCK0üҤɬס
	 */
	sil_wrh_mem((void *)PECRL1_h, 0x1111U);/* SCIF0:RTS0 CTS0 TxD0 RxD0 */
#if TNUM_PORT > 1
	sil_wrh_mem((void *)PECRL2_h, 0x0110U);/* SCIF1:TxD1 RxD1 */
#endif /* TNUM_PORT > 1 */
	
	/*
	 * СʡѤΥꥢ륳ȥν
	 */
	sh_scif_init(1);
#if TNUM_PORT > 1
	sh_scif_init(2);
#endif /* TNUM_PORT > 1 */
}

/*
 *	åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *	ץå¸ν
	 */
	prc_initialize();
}

/*
 *	åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *	ץå¸νλ
	 */
	prc_exit();

	/*
	 *	ȯĶ¸νλ
	 */
	apsh2ad_exit();

	/*
	 * ˤʤ
	 */
	while(1);
}

/*
 *	ƥ٥ϤΤʸ
 */
void
target_fput_log(char_t c)
{
#if TNUM_PORT == 1
	ID siopid = TARGET_PUTC_PORTID;
#else	/* TNUM_PORT == 1 */
	ID siopid = sil_get_pindex() + 1;
#endif	/* TNUM_PORT == 1 */

	if (c == '\n') {
		sh_scif_pol_putc('\r', siopid);
	}
	sh_scif_pol_putc(c, siopid);
}


/*
 *	μԻμ¹ǽT.B.D
 */
void
TOPPERS_assert_abort(void)
{
	uint_t index = sil_get_pindex();
	
	syslog(LOG_EMERG, "prcindex = %d" ,index);
	while(1);
}

