/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2007-2010 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: target_config.h 646 2010-07-01 06:44:52Z mit-kimai $
 */

/*
 *  åȰ¸⥸塼APSH2ADѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "apsh2ad.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"

/*
 *  Ϥ̤
 *  ɬפ˱asp/arch/logtrace/trace_dump.ctrace_print()
 *  б̤ɵ롣
 */
#define LOG_INH_ENTER			/*   17(0x11)  */
#define LOG_INH_LEAVE			/*  145(0x91)  */
#define LOG_EXC_ENTER			/*   22(0x16)  */
#define LOG_EXC_LEAVE			/*  150(0x96)  */

#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  åȰ¸ʸϤ˻ѤݡȤ
 *  (ƥʣΥץåǶͭ
 */
#define TARGET_PUTC_PORTID		1

/*
 *  FMPͥưΥޥåפȴϢ
 */

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#ifdef ROM_BOOT				/*  ROM  */
#define DEFAULT_PRC1_ISTKSZ      (1024 * 8)   /* 8KB */
#define DEFAULT_PRC2_ISTKSZ      (1024 * 8)   /* 8KB */
#else	/*  ROM_BOOT  */	/*  ǥХå  */
#define DEFAULT_PRC1_ISTKSZ      (1024 * 8)   /* 8KB */
#define DEFAULT_PRC2_ISTKSZ      (1024 * 8)   /* 8KB */
#endif /*  ROM_BOOT  */

/*	åΰ */
#define DEFAULT_PRC1_ISTK_BOTTOM		\
		(INNER_RAM0_PAGE3_ADDRESS_START + INNER_RAM_PAGE_SIZE)
#define DEFAULT_PRC2_ISTK_BOTTOM		\
		(INNER_RAM1_PAGE1_ADDRESS_START + INNER_RAM_PAGE_SIZE)

/*  åΰƬϡʥåΰǤϤʤΤǡա */
#define DEFAULT_PRC1_ISTK      			\
		(void *)(DEFAULT_PRC1_ISTK_BOTTOM - DEFAULT_PRC1_ISTKSZ)
#define DEFAULT_PRC2_ISTK      			\
		(void *)(DEFAULT_PRC2_ISTK_BOTTOM - DEFAULT_PRC2_ISTKSZ)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  str_ker() ǥޥץåǹԤ
 */
extern void target_mprc_initialize(void);

/*
 *  åȥƥ¸ν
 */
extern void target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ԤΤSILΥåȰ¸
 */
#ifdef ENABLE_CACHE		/*  ̿ᥭå夬ͭʾ  */
#define SIL_DLY_TIM1     238
#define SIL_DLY_TIM2     240

#elif defined(ROM_BOOT)		/*  ROMξ  */
#define SIL_DLY_TIM1     5618
#define SIL_DLY_TIM2     3118

#else				/*  RAMǥǥХå  */
#define SIL_DLY_TIM1     1940
#define SIL_DLY_TIM2     1323

#endif	/*  ENABLE_CACHEROM_BOOT  */

/*
 *  CCR1쥸ν
 */
#define CCR1_INIT		CCR1_ICE		/*  ̿ᥭåΤͭ  */

/*
 *  ߵĤͭˤʤޤǤλԤ򤹤뤿nop̿
 */
#ifdef ENABLE_CACHE		/*  ̿ᥭå夬ͭʾ  */
							/*  CPUINTCãޤǤٱ  */
							/*  ʥѥ3Icycʬ  */
#define ENAINT_NOP      nop; nop; nop; nop; nop; nop

#elif defined(ROM_BOOT)		/*  ROMξ  */
#define ENAINT_NOP

#else				/*  RAMǥǥХå  */
#define ENAINT_NOP      nop; nop

#endif	/*  ENABLE_CACHEROM_BOOT  */

/*
 *  ץå¸⥸塼SH7205ѡ
 */
#include "sh2a_dual_gcc/sh7205_config.h"

#endif  /* TOPPERS_TARGET_CONFIG_H */
