/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2007-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.h 739 2010-11-24 04:14:37Z ertl-honda $
 */

/*
 *  åװ¸⥸塼AT91SKYEYEѡ
 *
 *  ͥΥåװ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 *
 *  UMAǥǡ¤
 *  -> Ȥ롥 
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åץƥΥϡɥ񸻤
 */
#include "at91skyeye.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ݡȤƤSKYEYΥС
 */
#define SUPPORT_SKYEYE_VER  0x1024
#define SUPPORT_DEVM_VER    0x2020

/*
 *  ԥåǽ
 */
#ifndef TTYPE_SPN
#define TTYPE_SPN NATIVE_SPN
//#define TTYPE_SPN EMULATE_SPN
#endif /* TTYPE_SPN */

/*
 *  ͥƥ֥ԥξΥԥåκ
 */
#define TMAX_NATIVE_SPN   4

/*
 *  åID
 */
#if TTYPE_KLOCK == G_KLOCK

/* 㥤ȥå */
#define GIANT_LOCK  0x00

#else /* TTYPE_KLOCK == P_KLOCK */

/* ץåå */
#define PRC1_TSK_LOCK  0x00
#define PRC2_TSK_LOCK  0x02
#define PRC3_TSK_LOCK  0x04
#define PRC4_TSK_LOCK  0x06
#define PRC1_OBJ_LOCK  0x01
#define PRC2_OBJ_LOCK  0x03
#define PRC3_OBJ_LOCK  0x05
#define PRC4_OBJ_LOCK  0x07

#endif /* TTYPE_KLOCK == G_KLOCK */

/*
 *  ٥롼ʤΥ٥ɥ쥹Ƭ
 */ 
#define VECTOR_START  0x00

/*
 *  FMPͥưΥޥåפȴϢ
 */
#define RAM_START       RAM_BASE_ADDRESSS

#define FIQ_DATA_SIZE   256U

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#define DEFAULT_PRC1_ISTKSZ      (1024 * 8)   /* 8KB */
#define DEFAULT_PRC2_ISTKSZ      (1024 * 8)   /* 8KB */
#define DEFAULT_PRC3_ISTKSZ      (1024 * 8)   /* 8KB */
#define DEFAULT_PRC4_ISTKSZ      (1024 * 8)   /* 8KB */
                                                   
/*
 *  ԤΤSILΥåȰ¸
 */
#define SIL_DLY_TIM1    20
#define SIL_DLY_TIM2    10

/*
 *  ߥϥɥֹ˴ؤ
 */ 
#define TMIN_INHNO 0U
#define TMAX_INHNO 31U
#define TNUM_INH   32U

/*
 *  ֹ˴ؤ
 */ 
#define TMIN_INTNO 0U
#define TMAX_INTNO 31U
#define TNUM_INT   32U

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץåAPCBؤΥݥ󥿤μ
 *  󥯥롼ɽδط塤target_pcb.h ˤϵҤǤʤᤳ롥
 */
Inline APCB*
get_my_p_apcb(void)
{
	return(&((get_my_p_tpcb())->arm_pcb));
}

/*
 * ޥץåȽ
 */
Inline bool_t
x_sense_mprc(void){
	if(x_prc_index() == (TOPPERS_MASTER_PRCID - 1)) {
		return(true);
	}
	else{
		return(false);
	}
}

/*
 * ޥץåѵǽ
 */

#if TTYPE_KLOCK == G_KLOCK
/*
 *  㥤ȥåνG_LOCKξ
 */
Inline void
x_initialize_giant_lock(LOCK *p_giant_lock)
{
	*p_giant_lock = GIANT_LOCK;
}

#endif /* TTYPE_KLOCK == G_KLOCK */

#if TTYPE_KLOCK == P_KLOCK

/*
 *  åνP_LOCKξ
 */
Inline void
x_initialize_tsk_lock(LOCK *p_tsk_lock)
{
	if (x_prc_index() == 0) {
		*p_tsk_lock = PRC1_TSK_LOCK;
	}
	else if (x_prc_index() == 1) {
		*p_tsk_lock = PRC2_TSK_LOCK;
	}
	else if (x_prc_index() == 2) {
		*p_tsk_lock = PRC3_TSK_LOCK;
	}
	else if (x_prc_index() == 3) {
		*p_tsk_lock = PRC4_TSK_LOCK;
	}
}

/*
 *  ֥ȥåν
 */
Inline void
x_initialize_obj_lock(LOCK *p_obj_lock)
{
	if (x_prc_index() == 0) {
		*p_obj_lock = PRC1_OBJ_LOCK;
	}
	else if (x_prc_index() == 1) {
		*p_obj_lock = PRC2_OBJ_LOCK;
	}
	else if (x_prc_index() == 2) {
		*p_obj_lock = PRC3_OBJ_LOCK;
	}
	else if (x_prc_index() == 3) {
		*p_obj_lock = PRC4_OBJ_LOCK;
	}
}

#endif /* TTYPE_KLOCK == P_KLOCK */

/*
 *  ֹΥޥʲ16bitΤߤͭ
 */
#define INTNO_MASK(intno) (intno&0xffffU)

/*
 *  ֹ³ץåΥץåIDʾ16bit
 */
#define INTNO_PRCID(intno) (intno >> 16U)

/*
 *  ֹϰϤȽ
 *
 *  ӥåȥѥΤưפˤ뤿ˡ8Ϸ֤ˤʤäƤ롥
 */
#define VALID_INTNO(prcid, intno) (((TMIN_INTNO <= (INTNO_MASK(intno)) && (INTNO_MASK(intno)) <= TMAX_INTNO)) \
                                    && (INTNO_PRCID(intno) == prcid))
#define VALID_INTNO_DISINT(prcid, intno)	VALID_INTNO(prcid, intno)
#define VALID_INTNO_CFGINT(prcid, intno)	VALID_INTNO(prcid, intno)

/*
 *  ߥϥɥϿѥơ֥kernel_cfg.c
 */
extern const FP* const p_inh_table[TNUM_PRCID];

/*
 *  ߥϥɥͥ١kernel_cfg.c
 */
extern const PRI* const p_inh_ipm_table[TNUM_PRCID];

/*
 *  ߥϥɥ
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry, uint_t affinity_mask)
{

}

/*
 *  ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)

/*
 *  TOPPERSɸ߽ǥμ¸
 */
               
/*
 *  ͥ٥ޥ饤֥
 *
 *  AT91SAM7Sϳͥ٥ޥIRCǥϡɥŪ˻Ĥ
 *  եȥ¦ͤɤ߽񤭤Ǥʤᡤ׵ػߥե
 *  ˤͥ٥ޥ¸
 */
/*
 *  ͥΥޥѥkernel_cfg.h
 */
extern const uint32_t* const p_ipm_mask_table[TNUM_PRCID];

#define my_ipm_mask_table (p_ipm_mask_table[x_prc_index()])

#endif /* TOPPERS_MACRO_ONLY */  

/*
 *  IPMimp_mask_tableΥǥåѴޥ
 */
#define INDEX_IPM(ipm)  (-(ipm))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  (ǥ)ͥ٥ޥ
 * 
 *  ꤵ줿ͥ٤ꤵ줿׵ػߥե饰Υơ֥ͤȡʥ
 *  Ρ˳Ƴߤγ׵ػߥե饰ξ֤ݻѿͤȤ
 *  ORIRCγ׵ػߥե饰˥åȤꤷͥ٤ѿ
 *  ipm¸롥
 */
Inline void
x_set_ipm(PRI intpri)
{
	TPCB *p_tpcb;
	uint32_t ipm_mask;

	p_tpcb = get_my_p_tpcb();
	ipm_mask = my_ipm_mask_table[INDEX_IPM(intpri)];

	/*
	 *  AT91SAM7Sγߥȥϥ֥͡쥸
	 *  ꥢ쥸뤿ᡤöƤγߤػߤƤ顤
	 *  γߤΤߵĤɬפ
	 */
	/* ߶ػ */
	at91skyeye_disable_int(~0U);
	/* ޥꤵƤʤߤΤߵ */
	at91skyeye_enable_int(~(ipm_mask|(p_tpcb->idf)));
	p_tpcb->ipm = intpri;
}

#define t_set_ipm(intpri) x_set_ipm(intpri)
#define i_set_ipm(intpri) x_set_ipm(intpri)

/*
 *  (ǥ)ͥ٥ޥλ
 *
 *  ipm֤ͤ
 */
Inline PRI
x_get_ipm(void)
{
	TPCB *p_tpcb;

	p_tpcb = get_my_p_tpcb();

	return(p_tpcb->ipm);
}

#define t_get_ipm() x_get_ipm()
#define i_get_ipm() x_get_ipm()

/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
extern uint32_t	bitpat_cfgint;

/*
 * ʥǥΡ˳׵ػߥե饰Υå
 *
 *  ꤵ줿ֹγ׵ػߥե饰ΥåȤơߤ
 *  ػߤ롥ޤʥǥΡ˳׵ػߥե饰idf
 *  ӥåȤ򥻥åȤ롥
 *  ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	TPCB *p_tpcb = get_my_p_tpcb();

	if ((p_tpcb->bitpat_cfgint & INTNO_BITPAT(INTNO_MASK(intno))) == 0U) {
		return(false);
	}
	at91skyeye_disable_int(INTNO_BITPAT(INTNO_MASK(intno)));
	p_tpcb->idf |= INTNO_BITPAT(INTNO_MASK(intno));
	return(true);
}

#define t_disable_int(intno)  x_disable_int(intno)
#define i_disable_int(intno)  t_disable_int(intno)

/* 
 * (ǥ)׵ػߥե饰β
 *
 * ꤵ줿ֹγ׵ػߥե饰Υꥢơߤ
 * Ĥ롥ޤʥǥΡ˳׵ػߥե饰idf
 * ӥåȤ򥯥ꥢ롥
 * ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	TPCB *p_tpcb = get_my_p_tpcb();
	uint32_t ipm_mask = my_ipm_mask_table[INDEX_IPM(p_tpcb->ipm)];

	if ((p_tpcb->bitpat_cfgint & INTNO_BITPAT(INTNO_MASK(intno))) == 0U) {
		return(false);
	}
	p_tpcb->idf &= ~INTNO_BITPAT(INTNO_MASK(intno));
	/* ߶ػ */
	at91skyeye_disable_int(~0U);
	/* ޥꤵƤʤߤΤߵ */
	at91skyeye_enable_int(~(ipm_mask|(p_tpcb->idf)));

	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 * ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
	at91skyeye_clear_int(INTNO_BITPAT(INTNO_MASK(intno)));
}

#define t_clear_int(intno) x_clear_int(intno) 
#define i_clear_int(intno) x_clear_int(intno) 


/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
    return(at91skyeye_probe_int(INTNO_BITPAT(INTNO_MASK(intno))));
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ׵饤°
 *
 */
extern void x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask);

/*
 *  ߥϥɥɬפIRC
 *
 *  AT91SAM7SǤϡɬפʽϤʤ
 */
Inline void
i_begin_int(INTNO intno)
{
    
}

/*
 *  ߥϥɥνиɬפIRC
 *
 *  AT91SAM7SǤϡɬפʽϤʤ
 */
Inline void
i_end_int(INTNO intno)
{
    
}

/*
 *  åȥƥ¸ν
 */
extern void target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

/*
 *  ߥϥɥchip_support.S
 */
extern void interrupt_handler(void);

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);


/*
 *  ޥץåεǽ
 */

/*
 * ץåֳߤ˻ѤֹIRQ0
 */
#define INTERPROCLVL 16

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ¸⥸塼ARMѡ
 */
#include "arm_gcc/common/core_config.h"

#ifndef TOPPERS_MACRO_ONLY
/*
 *  åؿ
 *  x_lock_cpu()/x_unlock_cpu()Ȥᡤ¸⥸塼ARMѡˤ
 *  ɤ߹Ǥ롥 
 */
/*
 *  1ܤΥåʥ󥿥ƥȶѡ
 */
Inline void
x_acquire_lock(LOCK *p_lock)
{
	while(true) {
		sil_wrw_mem((void *)MUTEX_ID_REG, *p_lock);
		if(sil_rew_mem((void *)MUTEX_CNT_REG) == 1){
			/* å */
			Asm("":::"memory");
			return;
		}
		/* ߤε */
		x_unlock_cpu();
		x_lock_cpu();
	}
}

#define t_acquire_lock(p_lock) x_acquire_lock(p_lock)
#define i_acquire_lock(p_lock) x_acquire_lock(p_lock)

#if TTYPE_KLOCK != G_KLOCK

/*
 *  2ܰʾΥåʥ󥿥ƥȶѡ
 */
Inline bool_t
x_acquire_nested_lock(LOCK *p_lock)
{
	PCB		*p_pcb;

	while(true) {
		sil_wrw_mem((void *)MUTEX_ID_REG, *p_lock);
		if(sil_rew_mem((void *)MUTEX_CNT_REG) == 1){
			/* å */
			Asm("":::"memory");
			return(false);
		}
		/* ߤε */
		x_unlock_cpu();
		x_lock_cpu();
		/*
		 * ޥ졼󤹤ǽΤǤ  
		 * 󥿥ƥȤξ硤ޥ졼󤷤ʤᡤ
		 * while˼¹ԤƤ褤1ǥåȤ줿硤
		 * ΨΤǡǼ롥
		 */
		p_pcb = get_my_p_pcb(); 
		if (p_pcb->p_firstlock == NULL) {
			return(true);
		}
	}
}

#define t_acquire_nested_lock(p_lock) x_acquire_nested_lock(p_lock)
#define i_acquire_nested_lock(p_lock) x_acquire_nested_lock(p_lock)

#endif /* TTYPE_KLOCK != G_KLOCK */

/*
 *  åβʥ󥿥ƥȶѡ
 */
Inline void
x_release_lock(LOCK *p_lock)
{
	Asm("":::"memory");
	sil_wrw_mem((void *)MUTEX_ID_REG, *p_lock);
	sil_wrw_mem((void *)MUTEX_CNT_REG, 1);
}

/*
 *  Ĥʤåؿ
 */
Inline void 
x_acquire_lock_without_preemption(LOCK *p_lock)
{
	while(true) {
		sil_wrw_mem((void *)MUTEX_ID_REG, *p_lock);
		if(sil_rew_mem((void *)MUTEX_CNT_REG) == 1){
			/* å */
			Asm("":::"memory");
			return;
		}
	}
}

/*
 *  ԥåǽΥͥƥ֥åǻѤؿ
 */

/*
 *  ԥåηʥͥƥ֥åξ
 */
typedef uint32_t SPNLOCK;

/*
 *  ԥåIDºݤΥåIDؤѴ
 */
#define TO_NATIVE_ID(spnid)		(spnid + 19)

/*
 *  ԥåν
 */
Inline void
x_initialize_spin(ID spnid, SPNLOCK *p_spn_lock)
{
	*p_spn_lock = TO_NATIVE_ID(spnid);
	sil_wrw_mem((void *)MUTEX_ID_REG, *p_spn_lock);
	sil_wrw_mem((void *)MUTEX_CNT_REG, 1);
}

/*
 *  ԥåμ
 */
Inline void
x_lock_spin(SPNLOCK *p_spn_lock)
{
	x_acquire_lock(p_spn_lock);
}

#define t_lock_spin(p_spn_lock)  x_lock_spin(p_spn_lock)
#define i_lock_spin(p_spn_lock)  x_lock_spin(p_spn_lock)

/*
 *  ԥåμλ
 */
Inline bool_t
x_try_lock_spin(SPNLOCK *p_spn_lock)
{
	sil_wrw_mem((void *)MUTEX_ID_REG, *p_spn_lock);
	if (sil_rew_mem((void *)MUTEX_CNT_REG) != 1) {
		/*  */
		return(true);
	}
	else {
		/*  */
		Asm("":::"memory");
		return(false);
	}
}

/*
 *  ԥåֵ
 */
Inline void
x_unlock_spin(SPNLOCK *spn_lock)
{
	x_release_lock(spn_lock);
}

#ifdef TOPPERS_ENABLE_GCOV_PART
/*
 *  GCOVѥ饤֥
 */
/*
 *  GCOVؿ
 */
extern void gcov_init(void);

/*
 *  GCOVǴؿ
 */
extern void gcov_pause(void);

/*
 * GCOVƳؿ
 */
extern void gcov_resume(void);

/*
 *  GCOVϴؿ
 */
extern void gcov_dump(void);
#endif /* TOPPERS_ENABLE_GCOV_PART */
#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_TARGET_CONFIG_H */
